#include <stdio.h>
#include <math.h>

int R,C, Lr, Lc, Gr, Gc;

int get_dist(int a, int b, int x, int y)
{
	return fabs(x-a) + fabs(y-b);
}

int main()
{
	while(scanf("%d %d %d %d %d %d", &R,&C,&Gr,&Gc,&Lr,&Lc) == 6)
	{
		int d = get_dist(Gr, Gc, Lr, Lc);
		int x = fabs(Gr-Lr);
		int y = fabs(Gc-Lc);
		int result = 0;
		if (d == 0) {
			printf("0\n");
		}
		else if (R == 1 || C == 1) {
			printf("impossible\n");
		} else if (R == 2 || C == 2) {
			int t = (x > y) ? x : y;
			if (Gc == Lc || Gr == Lr) {
				if (t % 4 == 0) {
					printf("%d\n", t/2);
				} else printf("impossible\n");
			} else {
				if ((t+2) % 4 == 0) {
					printf("%d\n", t/2);
				} else printf("impossible\n");
			}
		} else if (R == 3 && C == 3) {
			if (Lr == 2 && Lc == 2) printf("impossible\n");
			else if (Gr == 2 && Gc == 2) printf("impossible\n");
			else {
				switch(d) {
					case 1:
						printf("3\n");
						break;
					case 2:
						printf("2\n");
						break;
					case 3:
						printf("1\n");
						break;
					case 4:
						printf("4\n");
						break;
					case 5:
						printf("3\n");
						break;
				}
			}
		} else if ((R == 4 || C == 4) && (x == 0 || y == 0) && d == 5) {
			printf("5\n");
		} else {
			while (x > 2 || y > 2 ) {
				if (x > y) {
					x -= 2;
					y--;
					if (y<0) y = 1;
				} else {
					y -= 2;
					x--;
					if (x<0) x = 1;
				}
				result++;
			}
			switch(x+y) {
				case 1:
					printf("%d\n", result+3);
					break;
				case 2:
					printf("%d\n", result+2);
					break;
				case 3:
					printf("%d\n", result+1);
					break;
				case 4:
					printf("%d\n", result+4);
					break;
			}
		}
	}
	return 0;
}
